unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FindFile, StdCtrls, ExtCtrls;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

  TMainForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FTimerThread: TTimerThread;
  private
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  protected
    procedure CreateParams(var Params: TCreateParams);override;
    procedure UpdateList();
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    ShellApi;

{$R *.dfm}

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    MainForm.UpdateList();
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(1);
    end;
end;

//=============================================================================
//  TMainForm implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
begin
    FTimerThread := TTimerThread.Create(False);
    GFindFileThread.Resume();
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FTimerThread.Free();
    //  ȂLZ
    GFindFileThread.Cancel();
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    LPathName: Array[0..MAX_PATH] of Char;
    i, LCount: integer;
begin
    //  hbvꂽt@C̐擾
    LCount := DragQueryFile(Msg.Drop, DWORD(-1), LPathName, SizeOf(LPathName));
    for i := 0 to LCount - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, LPathName, SizeOf(LPathName));
        //  Xbhɒǉ
        GFindFileThread.PutPath(LPathName);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  LZ
procedure TMainForm.Button1Click(Sender: TObject);
begin
    GFindFileThread.Cancel();
end;

//-----------------------------------------------------------------------------
//  Xbh猋ʂo
procedure TMainForm.UpdateList();
begin
    Label1.Caption := GFindFileThread.CurrentPath;
    if (GFindFileThread.ResultCount > 0) then
    begin
        ListBox1.Items.BeginUpdate();
        GFindFileThread.GetResult(ListBox1.Items);
        ListBox1.Items.EndUpdate();
    end;
end;

end.
